/* $Id: guidedmissile.hpp,v 1.2 2005/10/14 14:17:20 pohlt Exp $ */

#ifndef _GUIDEDMISSILE_HPP_
#define _GUIDEDMISSILE_HPP_

/**********************************************************/

#include "missile.hpp"

/**********************************************************/

//! Guided Missile
class GuidedMissile : public Missile
{
	friend class WeaponGuidedMissile;

	public:
	
		GuidedMissile();

		//! overwritten from class Missile
		bool initialize( const Vector& pos,
		                 const Vector& vel,
		                 const Uint8   owner,
		                 const Sint32  nShrapnels,
		                 const Sint32  damage,
		                 const Vector& thrust );

		//! overwritten from class Object
		virtual Sint32 getID() const { return GUIDED_MISSILE; }

		virtual void update();
		virtual void explode( void );

		void updateSpriteSelection( const bool activeEngine );

		virtual void serialize( Uint8*& bufferPointer ) const;
		virtual void deserialize( Uint8*& bufferPointer );
		virtual Uint32 getSerializeBufferSize() const;

	protected:
		real m_angle;
};

/**********************************************************/

#endif // _GUIDEDMISSILE_HPP_
